#include <stdio.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <net/if.h>
#include <stdlib.h>
#include "util.h"

int main(int argc, char **argv)
{
	int sock = socket(AF_INET,SOCK_DGRAM,0),i;
	int fp,j, file_flag = 0;	 
	struct ifreq rq;
	ioctlInfo_t io;
	unsigned char *c, dev[10],path[30];

	if((argc < 4) || (argc > 6)) {
		printf("Usage: ./util -i<I/F name> -f<o/p file> options\n");
		printf("Options, 1=TxD, 2=stats, 3=get Gen int status reg, 4=RxD"); 
		printf(", 5=Rx Buffer, 6=Reg <offset>, 7=write <offset> <value>");
		printf(", 8=reset\n");
		return 0;
	}
	if((argc > 3) && (argc < 7)) {
		if((argv[1][0] != '-')||(argv[1][1] != 'i')) {
			printf("Please enter the target device name prefixed with a '-i'");
			printf(" to run a particular option o util on that device.\n");
			printf("Eg: ./util -ieth0 -f/tmp/dummy 6 108\n");
			return 0;
		}
		if((argv[2][0] != '-')||(argv[2][1] != 'f')) {
			printf("Enter the output file name. Not ll options dump data ");
			printf(", but its mandatory to give an output file\n");
			printf("Eg: ./util -ieth0 -f/tmp/dummy 6 108\n");
			return 0;
		}
		file_flag = 1;
		for(i=2; argv[2][i]; i++)
			path[i-2] = argv[2][i];
		if(i == 2) {
			printf("Enter the output file name. Not ll options dump data ");
			printf(", but its mandatory to give an output file\n");
			printf("Eg: ./util -ieth0 -f/tmp/dummy 6 108\n");
			return 0;
		}
		path[i-2] = '\0';
		if((argc != 5)&&(argv[3][0] == '6'))
			return 0;
		if((argc != 6)&&(argv[3][0] == '7'))
			return 0;
/*
		printf("Options, 1=TxD, 2=stats, 3=get Gen int status reg, 4=RxD"); 
		printf(", 5=Rx Buffer, 6=Reg <offset>, 7=write <offset> <value>");
		printf(", 8=reset\n");
		return 0;
	out:
*/
	}

	if(file_flag) {
	fp = open(path,  O_CREAT| O_RDWR),j;
	}
	else {
	fp = open("/tmp/dump",  O_CREAT| O_RDWR),j;
	}	

	for(i=2; argv[1][i]; i++)
		rq.ifr_name[i-2] = argv[1][i];
	if(i==2) {
		printf("Please enter the device name\n");
		printf("Eg: ./util -ieth0 6 108\n");
		close(fp);
		return 0;
	}
	rq.ifr_name[i-2] = '\0';

	printf("Dev: %s\n",rq.ifr_name);
	c          = (unsigned char *)malloc(0x140000);
	io.buffer  = (unsigned char *)malloc(0x40000);
	io.buffer1 = (unsigned char *)malloc(0x40000);
	io.buffer2 = (unsigned char *)malloc(0x40000);
	io.buffer3 = (unsigned char *)malloc(0x40000);
	io.buffer4 = (unsigned char *)malloc(0x40000);
	io.buffer5 = (unsigned char *)malloc(0x40000);
	io.buffer6 = (unsigned char *)malloc(0x40000);

	if(!io.buffer) {
	printf("EERROR in alloc");
	close(fp);
	return -1;
	}	
	rq.ifr_data = (char *)&io;
	if(argv[3][0] == '1') {
		if(!(ioctl(sock, SIOCDEVPRIVATE+4, &rq))) {
			printf("TXD data, size: %d\n", io.size);
			write(fp, io.buffer, io.size);
		}
		else
			printf("Ioctl failed\n");
	}
	else if(argv[3][0] == '2') {
		if(!(ioctl(sock, SIOCDEVPRIVATE+5, &rq))) {
			printf("Stat data, size: %d\n",io.size);
			write(fp, io.buffer, io.size);
		}
		else
			printf("Ioctl failed\n");
	}	
	else if(argv[3][0] == '3') {
		if(!(ioctl(sock, SIOCDEVPRIVATE+6, &rq))) {
			printf("Gen Int status: 0x%llx\n", io.value);
		}
		else
			printf("Ioctl failed\n");
	}
	else if(argv[3][0] == '4') {
		if(!(ioctl(sock, SIOCDEVPRIVATE+7, &rq))) {
			printf("RxD data, size: %d\n", io.size);
            memcpy(c, io.buffer, 0x40000);
            memcpy((c+0x40000), io.buffer1, 0x40000);
            memcpy((c+0x80000), io.buffer2, 0x40000);
            memcpy((c+0xc0000), io.buffer3, 0x40000);
            memcpy((c+0x100000), io.buffer4, 0x40000);
			write(fp, c, io.size);
		}
		else
			printf("Ioctl failed\n");
	}
	else if(argv[3][0] == '5') {
		if(!(ioctl(sock, SIOCDEVPRIVATE+8, &rq))) {
			printf("RxD buffer, size: %d\n", io.size);
			write(fp, io.buffer, io.size);
		}
		else
			printf("Ioctl failed\n");
	}
	else if(argv[3][0] == '6') {
		io.offset = strtoull(argv[4], NULL, 16);
		if(!(ioctl(sock, SIOCDEVPRIVATE+9, &rq))) {
			printf("Reg at offset: 0x%x is: 0x%llx\n", io.offset,io.value);
		}
		else
			printf("Ioctl failed\n");
	}
	else if(argv[3][0] == '7') {
		char *c = argv[5];
		int len = strlen(c);
		unsigned long long val64, tmp64;

		io.offset = strtoull(argv[4], NULL, 16);
		
		if(len > 8) {
			char lo[9], hi[9];
			memcpy(hi, c, (len-8));	
			hi[len-8] = '\0';
			memcpy(lo, (c+(len-8)), 8);	
			lo[8] = '\0';

			printf("datai hi: 0x%s\n",hi);
			printf("datai lo: 0x%s\n",lo);
			val64 = strtoull(hi, NULL, 16);
			tmp64 = strtoull(lo, NULL, 16);

			val64 <<= (32);
			val64 |= (unsigned long)tmp64;
		}
		else
			val64 = strtoull(argv[5], NULL, 16);
		io.value = val64;
		printf("Reg at offset: 0x%x is: 0x%llx\n", io.offset,io.value);
		if(!(ioctl(sock, SIOCDEVPRIVATE+10, &rq))) {
			printf("Reg at offset: 0x%x is: 0x%llx\n", io.offset,io.value);
		}
		else
			printf("Ioctl failed\n");
	}
	else if(argv[3][0] == '8') {
		if(!(ioctl(sock, SIOCDEVPRIVATE+11, &rq))) {
			printf("Resetting the Card\n");
		}
		else
			printf("Ioctl failed\n");
	}
	else
		printf("Wrong option\n");	

	close(fp);
	return 0;
}
/*
 *$Log: util.c,v $
 *Revision 1.15  2004/02/09 19:59:23  aravi
 *Bug: 697
 *Restoring version 1.12 as per discussion with h/w team.
 *
 *Revision 1.12  2003/11/04 02:10:14  ukiran
 *Bug:484
 *Enabling Logs in source code
 *
 *Revision 1.11  2003/11/04 02:07:10  ukiran
 *Bug:484
 *Enabling Logs in source code
 *
 */

